Index: uspace/lib/usbdev/include/usb/dev/dp.h
===================================================================
--- uspace/lib/usbdev/include/usb/dev/dp.h	(revision 7d521e248cf09e5e6637a3ddfb9a8c2d4ac5d716)
+++ uspace/lib/usbdev/include/usb/dev/dp.h	(revision 160b75e098f96312d13cf8c93e26f0ee3e46c1a5)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libusb
+/** @addtogroup libusbdev
  * @{
  */
Index: uspace/lib/usbdev/include/usb/dev/driver.h
===================================================================
--- uspace/lib/usbdev/include/usb/dev/driver.h	(revision 7d521e248cf09e5e6637a3ddfb9a8c2d4ac5d716)
+++ uspace/lib/usbdev/include/usb/dev/driver.h	(revision 160b75e098f96312d13cf8c93e26f0ee3e46c1a5)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libusb
+/** @addtogroup libusbdev
  * @{
  */
Index: uspace/lib/usbdev/include/usb/dev/hc.h
===================================================================
--- uspace/lib/usbdev/include/usb/dev/hc.h	(revision 7d521e248cf09e5e6637a3ddfb9a8c2d4ac5d716)
+++ uspace/lib/usbdev/include/usb/dev/hc.h	(revision 160b75e098f96312d13cf8c93e26f0ee3e46c1a5)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libusb
+/** @addtogroup libusbdev
  * @{
  */
Index: uspace/lib/usbdev/include/usb/dev/hub.h
===================================================================
--- uspace/lib/usbdev/include/usb/dev/hub.h	(revision 7d521e248cf09e5e6637a3ddfb9a8c2d4ac5d716)
+++ uspace/lib/usbdev/include/usb/dev/hub.h	(revision 160b75e098f96312d13cf8c93e26f0ee3e46c1a5)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libusb
+/** @addtogroup libusbdev
  * @{
  */
Index: uspace/lib/usbdev/include/usb/dev/pipes.h
===================================================================
--- uspace/lib/usbdev/include/usb/dev/pipes.h	(revision 7d521e248cf09e5e6637a3ddfb9a8c2d4ac5d716)
+++ uspace/lib/usbdev/include/usb/dev/pipes.h	(revision 160b75e098f96312d13cf8c93e26f0ee3e46c1a5)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libusb
+/** @addtogroup libusbdev
  * @{
  */
Index: uspace/lib/usbdev/include/usb/dev/poll.h
===================================================================
--- uspace/lib/usbdev/include/usb/dev/poll.h	(revision 7d521e248cf09e5e6637a3ddfb9a8c2d4ac5d716)
+++ uspace/lib/usbdev/include/usb/dev/poll.h	(revision 160b75e098f96312d13cf8c93e26f0ee3e46c1a5)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libusb
+/** @addtogroup libusbdev
  * @{
  */
Index: uspace/lib/usbdev/include/usb/dev/recognise.h
===================================================================
--- uspace/lib/usbdev/include/usb/dev/recognise.h	(revision 7d521e248cf09e5e6637a3ddfb9a8c2d4ac5d716)
+++ uspace/lib/usbdev/include/usb/dev/recognise.h	(revision 160b75e098f96312d13cf8c93e26f0ee3e46c1a5)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libusb
+/** @addtogroup libusbdev
  * @{
  */
Index: uspace/lib/usbdev/include/usb/dev/request.h
===================================================================
--- uspace/lib/usbdev/include/usb/dev/request.h	(revision 7d521e248cf09e5e6637a3ddfb9a8c2d4ac5d716)
+++ uspace/lib/usbdev/include/usb/dev/request.h	(revision 160b75e098f96312d13cf8c93e26f0ee3e46c1a5)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libusb
+/** @addtogroup libusbdev
  * @{
  */
Index: uspace/lib/usbdev/src/altiface.c
===================================================================
--- uspace/lib/usbdev/src/altiface.c	(revision 7d521e248cf09e5e6637a3ddfb9a8c2d4ac5d716)
+++ uspace/lib/usbdev/src/altiface.c	(revision 160b75e098f96312d13cf8c93e26f0ee3e46c1a5)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libusb
+/** @addtogroup libusbdev
  * @{
  */
Index: uspace/lib/usbdev/src/devdrv.c
===================================================================
--- uspace/lib/usbdev/src/devdrv.c	(revision 7d521e248cf09e5e6637a3ddfb9a8c2d4ac5d716)
+++ uspace/lib/usbdev/src/devdrv.c	(revision 160b75e098f96312d13cf8c93e26f0ee3e46c1a5)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libusb
+/** @addtogroup libusbdev
  * @{
  */
Index: uspace/lib/usbdev/src/devpoll.c
===================================================================
--- uspace/lib/usbdev/src/devpoll.c	(revision 7d521e248cf09e5e6637a3ddfb9a8c2d4ac5d716)
+++ uspace/lib/usbdev/src/devpoll.c	(revision 160b75e098f96312d13cf8c93e26f0ee3e46c1a5)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libusb
+/** @addtogroup libusbdev
  * @{
  */
Index: uspace/lib/usbdev/src/dp.c
===================================================================
--- uspace/lib/usbdev/src/dp.c	(revision 7d521e248cf09e5e6637a3ddfb9a8c2d4ac5d716)
+++ uspace/lib/usbdev/src/dp.c	(revision 160b75e098f96312d13cf8c93e26f0ee3e46c1a5)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libusb
+/** @addtogroup libusbdev
  * @{
  */
Index: uspace/lib/usbdev/src/hub.c
===================================================================
--- uspace/lib/usbdev/src/hub.c	(revision 7d521e248cf09e5e6637a3ddfb9a8c2d4ac5d716)
+++ uspace/lib/usbdev/src/hub.c	(revision 160b75e098f96312d13cf8c93e26f0ee3e46c1a5)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libusb
+/** @addtogroup libusbdev
  * @{
  */
Index: uspace/lib/usbdev/src/pipepriv.c
===================================================================
--- uspace/lib/usbdev/src/pipepriv.c	(revision 7d521e248cf09e5e6637a3ddfb9a8c2d4ac5d716)
+++ uspace/lib/usbdev/src/pipepriv.c	(revision 160b75e098f96312d13cf8c93e26f0ee3e46c1a5)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libusb
+/** @addtogroup libusbdev
  * @{
  */
Index: uspace/lib/usbdev/src/pipepriv.h
===================================================================
--- uspace/lib/usbdev/src/pipepriv.h	(revision 7d521e248cf09e5e6637a3ddfb9a8c2d4ac5d716)
+++ uspace/lib/usbdev/src/pipepriv.h	(revision 160b75e098f96312d13cf8c93e26f0ee3e46c1a5)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libusb
+/** @addtogroup libusbdev
  * @{
  */
@@ -33,6 +33,6 @@
  * Library internal functions on USB pipes.
  */
-#ifndef LIBUSB_PIPEPRIV_H_
-#define LIBUSB_PIPEPRIV_H_
+#ifndef LIBUSBDEV_PIPEPRIV_H_
+#define LIBUSBDEV_PIPEPRIV_H_
 
 #include <usb/dev/pipes.h>
Index: uspace/lib/usbdev/src/pipes.c
===================================================================
--- uspace/lib/usbdev/src/pipes.c	(revision 7d521e248cf09e5e6637a3ddfb9a8c2d4ac5d716)
+++ uspace/lib/usbdev/src/pipes.c	(revision 160b75e098f96312d13cf8c93e26f0ee3e46c1a5)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libusb
+/** @addtogroup libusbdev
  * @{
  */
Index: uspace/lib/usbdev/src/pipesinit.c
===================================================================
--- uspace/lib/usbdev/src/pipesinit.c	(revision 7d521e248cf09e5e6637a3ddfb9a8c2d4ac5d716)
+++ uspace/lib/usbdev/src/pipesinit.c	(revision 160b75e098f96312d13cf8c93e26f0ee3e46c1a5)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libusb
+/** @addtogroup libusbdev
  * @{
  */
Index: uspace/lib/usbdev/src/pipesio.c
===================================================================
--- uspace/lib/usbdev/src/pipesio.c	(revision 7d521e248cf09e5e6637a3ddfb9a8c2d4ac5d716)
+++ uspace/lib/usbdev/src/pipesio.c	(revision 160b75e098f96312d13cf8c93e26f0ee3e46c1a5)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libusb
+/** @addtogroup libusbdev
  * @{
  */
Index: uspace/lib/usbdev/src/recognise.c
===================================================================
--- uspace/lib/usbdev/src/recognise.c	(revision 7d521e248cf09e5e6637a3ddfb9a8c2d4ac5d716)
+++ uspace/lib/usbdev/src/recognise.c	(revision 160b75e098f96312d13cf8c93e26f0ee3e46c1a5)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libusb
+/** @addtogroup libusbdev
  * @{
  */
Index: uspace/lib/usbdev/src/request.c
===================================================================
--- uspace/lib/usbdev/src/request.c	(revision 7d521e248cf09e5e6637a3ddfb9a8c2d4ac5d716)
+++ uspace/lib/usbdev/src/request.c	(revision 160b75e098f96312d13cf8c93e26f0ee3e46c1a5)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libusb
+/** @addtogroup libusbdev
  * @{
  */
Index: uspace/lib/usbdev/src/usbdevice.c
===================================================================
--- uspace/lib/usbdev/src/usbdevice.c	(revision 7d521e248cf09e5e6637a3ddfb9a8c2d4ac5d716)
+++ uspace/lib/usbdev/src/usbdevice.c	(revision 160b75e098f96312d13cf8c93e26f0ee3e46c1a5)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup libusb
+/** @addtogroup libusbdev
  * @{
  */